#ifndef TYPE_Action 
#define TYPE_Action 
#include "TYPE_Action.h" 
#endif
#ifndef TYPE_Exceptions 
#define TYPE_Exceptions 
#include "TYPE_EXCEPTIONS.h" 
#endif
#ifndef TYPE_Amount 
#define TYPE_Amount 
#include "TYPE_Amount.h" 
#endif
#ifndef TYPE_ID 
#define TYPE_ID 
#include "TYPE_ID.h" 
#endif
#include "XcD_PACKAGE.h"
#define CompositeName GasStation
#ifndef CompositeID
#define CompositeID 0
#endif
#ifndef COMPONENT_TYPE_Customer
#define COMPONENT_TYPE_Customer
#include  "COMPONENT_TYPE_Customer.h"
#endif

#ifndef COMPONENT_TYPE_Cashier
#define COMPONENT_TYPE_Cashier
#include  "COMPONENT_TYPE_Cashier.h"
#endif

#ifndef COMPONENT_TYPE_Pump
#define COMPONENT_TYPE_Pump
#include  "COMPONENT_TYPE_Pump.h"
#endif


#ifndef CONNECTOR_TYPE_Customer_Cashier_conn1_0_ROLE_Customer
#define CONNECTOR_TYPE_Customer_Cashier_conn1_0_ROLE_Customer
#include "CONNECTOR_TYPE_Customer_Cashier_conn1_0_ROLE_Customer.h"
#endif
#ifndef CONNECTOR_TYPE_Customer_Cashier_conn1_0_ROLE_Cashier
#define CONNECTOR_TYPE_Customer_Cashier_conn1_0_ROLE_Cashier
#include "CONNECTOR_TYPE_Customer_Cashier_conn1_0_ROLE_Cashier.h"
#endif

#ifndef CONNECTOR_TYPE_Customer_Pump_conn2_0_ROLE_Customer
#define CONNECTOR_TYPE_Customer_Pump_conn2_0_ROLE_Customer
#include "CONNECTOR_TYPE_Customer_Pump_conn2_0_ROLE_Customer.h"
#endif
#ifndef CONNECTOR_TYPE_Customer_Pump_conn2_0_ROLE_Pump
#define CONNECTOR_TYPE_Customer_Pump_conn2_0_ROLE_Pump
#include "CONNECTOR_TYPE_Customer_Pump_conn2_0_ROLE_Pump.h"
#endif

#ifndef CONNECTOR_TYPE_Cashier_Pump_conn3_0_ROLE_Cashier
#define CONNECTOR_TYPE_Cashier_Pump_conn3_0_ROLE_Cashier
#include "CONNECTOR_TYPE_Cashier_Pump_conn3_0_ROLE_Cashier.h"
#endif
#ifndef CONNECTOR_TYPE_Cashier_Pump_conn3_0_ROLE_Pump
#define CONNECTOR_TYPE_Cashier_Pump_conn3_0_ROLE_Pump
#include "CONNECTOR_TYPE_Cashier_Pump_conn3_0_ROLE_Pump.h"
#endif



chan CHANNEL_GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer[1] = [1] of {mtype,int};

chan CHANNELREQ_GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil[1] = [1] of {byte,mtype};
chan CHANNELRES_GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil[1] = [1] of {byte,mtype,bit,byte};
chan CHANNEL_GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier[1] = [1] of {mtype,int,int};

#define CONNECTOR_Customer_Cashier_conn1_0_ROLE_Customer_VAR_amount COMPONENT_Customer_VAR_amount[0]
#define CONNECTOR_Customer_Cashier_conn1_0_ROLE_Customer_VAR_PORT_pay_INDEX COMPONENT_Customer_VAR_PORT_pay_INDEX



#define CONNECTOR_Customer_Pump_conn2_0_ROLE_Customer_VAR_PORT_gas_INDEX COMPONENT_Customer_VAR_PORT_gas_INDEX



#define CONNECTOR_Customer_Cashier_conn1_0_ROLE_Cashier_VAR_amount_arg COMPONENT_Cashier_VAR_amount_arg[0]
#define CONNECTOR_Customer_Cashier_conn1_0_ROLE_Cashier_VAR_PORT_customer_INDEX COMPONENT_Cashier_VAR_PORT_customer_INDEX


#define CONNECTOR_Cashier_Pump_conn3_0_ROLE_Cashier_VAR_pumpID COMPONENT_Cashier_VAR_pumpID[0]
#define CONNECTOR_Cashier_Pump_conn3_0_ROLE_Cashier_VAR_amount COMPONENT_Cashier_VAR_amount[0]
#define CONNECTOR_Cashier_Pump_conn3_0_ROLE_Cashier_VAR_PORT_toPump_INDEX COMPONENT_Cashier_VAR_PORT_toPump_INDEX




#define CONNECTOR_Customer_Pump_conn2_0_ROLE_Pump_VAR_PORT_oil_INDEX COMPONENT_Pump_VAR_PORT_oil_INDEX


#define CONNECTOR_Cashier_Pump_conn3_0_ROLE_Pump_VAR_pumpID COMPONENT_Pump_VAR_pumpID[0]
#define CONNECTOR_Cashier_Pump_conn3_0_ROLE_Pump_VAR_amount COMPONENT_Pump_VAR_amount[0]
#define CONNECTOR_Cashier_Pump_conn3_0_ROLE_Pump_VAR_PORT_fromCashier_INDEX COMPONENT_Pump_VAR_PORT_fromCashier_INDEX




//Component Instance : Customer_cust1_0
#define Instance 0
#define CompInstanceID cust1
chan component_i_blockedChannel(CompositeName, CompositeID,Customer,CompInstanceID,Instance) = [0] of {mtype};
#define CHANNEL_GasStation_0_COMPONENT_Customer_cust1_0_PORT_pay_ACTION_pay \
if\
::COMPONENT_Customer_VAR_PORT_pay_INDEX==0->\
CHANNEL_GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer[0]!pay,COMPONENT_Customer_VAR_amount[0] \
fi

#define CHANNELREQ_GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas_ACTION_pump \
if\
::COMPONENT_Customer_VAR_PORT_gas_INDEX==0->\
CHANNELREQ_GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil[0]! _pid,pump \
fi

#define CHANNELRES_GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas \
atomic{\
CHANNELRES_COMPONENT_Customer_VAR_PORT_gas[Component_i_Port_Num(CompositeName,CompositeID,Customer,CompInstanceID,Instance,gas)]=component_i_blockedChannel(CompositeName,CompositeID,Customer,CompInstanceID,Instance) ;\
COMPONENT_Customer_VAR_PORT_gas_INDEX=0; \
do \
::COMPONENT_Customer_VAR_PORT_gas_INDEX==0->\
CHANNELRES_COMPONENT_Customer_VAR_PORT_gas[COMPONENT_Customer_VAR_PORT_gas_INDEX]=CHANNELRES_GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil[0]; \
COMPONENT_Customer_VAR_PORT_gas_INDEX++ \
::else->COMPONENT_Customer_VAR_PORT_gas_INDEX=0; break \
od\
}



#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_pay_NUM  1 
#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas_NUM  1 

#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_pay_ACTION_pay_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_Customer_PORT_pay_ACTION_pay_PRE && (COMPONENT_Customer_VAR_PORT_pay_INDEX==0->ICONTRACT_CONNECTOR_Customer_Cashier_conn1_0_ROLE_Customer_PORTVAR_pay_ACTION_pay_PRE: true)  
#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas_ACTION_pump_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_Customer_PORT_gas_ACTION_pump_PRE && (COMPONENT_Customer_VAR_PORT_gas_INDEX==0->ICONTRACT_CONNECTOR_Customer_Pump_conn2_0_ROLE_Customer_PORTVAR_gas_ACTION_pump_PRE: true) 





 #define GasStation_0_COMPONENT_Customer_cust1_0_PORT_pay_0_ACTION_pay_ROLE_DATAUPDATE() \
true

#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_pay_ACTION_pay_ROLE_DATAUPDATE() \
if\
::COMPONENT_Customer_VAR_PORT_pay_INDEX == 0 -> \
  GasStation_0_COMPONENT_Customer_cust1_0_PORT_pay_0_ACTION_pay_ROLE_DATAUPDATE() \
fi; 
 

#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas_0_ACTION_pump_ROLE_DATAUPDATE() \
true

#define GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas_ACTION_pump_ROLE_DATAUPDATE() \
if\
::COMPONENT_Customer_VAR_PORT_gas_INDEX == 0 -> \
  GasStation_0_COMPONENT_Customer_cust1_0_PORT_gas_0_ACTION_pump_ROLE_DATAUPDATE() \
fi; 


#define COMPONENT_Customer_cust1_0_ROLE_DATA() \
 true 

#define XX GasStation
#include "COMPONENT_TYPE_Customer_INSTANCE.pml"
#undef CompInstanceID 
#undef Instance 
#undef XX 

//Component Instance : Cashier_cash1_0
#define Instance 0
#define CompInstanceID cash1
chan component_i_blockedChannel(CompositeName, CompositeID,Cashier,CompInstanceID,Instance)= [0] of {mtype};
#define CHANNEL_GasStation_0_COMPONENT_Cashier_cash1_0_PORT_toPump_ACTION_releasePump \
if\
::COMPONENT_Cashier_VAR_PORT_toPump_INDEX==0->\
CHANNEL_GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier[0]!releasePump,COMPONENT_Cashier_VAR_pumpID[0],COMPONENT_Cashier_VAR_amount[0] \
fi


#define GasStation_0_COMPONENT_Cashier_cash1_0_PARAM_N 1

#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_NUM  1 
#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_toPump_NUM  1 

#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_ACTION_pay_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_Cashier_PORT_customer_ACTION_pay_PRE && (COMPONENT_Cashier_VAR_PORT_customer_INDEX==0->ICONTRACT_CONNECTOR_Customer_Cashier_conn1_0_ROLE_Cashier_PORTVAR_customer_ACTION_pay_PRE: true)  
#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_ACTION_pay_REFINED_ICONTRACT_REJECT() \
ICONTRACT_COMPONENT_Cashier_PORT_customer_ACTION_pay_PRE_REJECT && (COMPONENT_Cashier_VAR_PORT_customer_INDEX==0->ICONTRACT_CONNECTOR_Customer_Cashier_conn1_0_ROLE_Cashier_PORTVAR_customer_ACTION_pay_PRE: true)  
#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_toPump_ACTION_releasePump_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_Cashier_PORT_toPump_ACTION_releasePump_PRE && (COMPONENT_Cashier_VAR_PORT_toPump_INDEX==0->ICONTRACT_CONNECTOR_Cashier_Pump_conn3_0_ROLE_Cashier_PORTVAR_toPump_ACTION_releasePump_PRE: true)  

#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_0_CONNECTIONS 1


#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_SUMCONNECTIONS \
GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_0_CONNECTIONS  
#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_NUMOFCONNECTIONS \
(\
COMPONENT_Cashier_VAR_PORT_customer_INDEX==0->GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_0_CONNECTIONS :0)\




#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_0_ACTION_pay_ROLE_DATAUPDATE() \
true

#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_ACTION_pay_ROLE_DATAUPDATE() \
if\
::COMPONENT_Cashier_VAR_PORT_customer_INDEX == 0 -> \
  GasStation_0_COMPONENT_Cashier_cash1_0_PORT_customer_0_ACTION_pay_ROLE_DATAUPDATE() \
fi; 
 

 #define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_toPump_0_ACTION_releasePump_ROLE_DATAUPDATE() \
true

#define GasStation_0_COMPONENT_Cashier_cash1_0_PORT_toPump_ACTION_releasePump_ROLE_DATAUPDATE() \
if\
::COMPONENT_Cashier_VAR_PORT_toPump_INDEX == 0 -> \
  GasStation_0_COMPONENT_Cashier_cash1_0_PORT_toPump_0_ACTION_releasePump_ROLE_DATAUPDATE() \
fi; 
 

#define COMPONENT_Cashier_cash1_0_ROLE_DATA() \
 true 

c_code { 
int Component_i_port_offsetArray(CompositeName,CompositeID,Cashier,CompInstanceID,0,customer)[Component_i_Port_Num(CompositeName,CompositeID,Cashier,CompInstanceID,0,customer)];
}


#define GasStation_0_COMPONENT_Cashier_cash1_0_ARRAY_INITIALISATIONS() \
c_code { \ 
Component_i_port_offsetArray(CompositeName,CompositeID,Cashier,CompInstanceID,0,customer)[0] = 0;\
} 

#define XX GasStation
#include "COMPONENT_TYPE_Cashier_INSTANCE.pml"
#undef CompInstanceID 
#undef Instance 
#undef XX 

//Component Instance : Pump_pump1_0
#define Instance 0
#define CompInstanceID pump1
chan component_i_blockedChannel(CompositeName, CompositeID,Pump,CompInstanceID,Instance)= [0] of {mtype};

#define GasStation_0_COMPONENT_Pump_pump1_0_PARAM_N 1

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_NUM  1 
#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_NUM  1 

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_ACTION_pump_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_Pump_PORT_oil_ACTION_pump_PRE && (COMPONENT_Pump_VAR_PORT_oil_INDEX==0->ICONTRACT_CONNECTOR_Customer_Pump_conn2_0_ROLE_Pump_PORTVAR_oil_ACTION_pump_PRE_REQUEST: true) 

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_ACTION_pump_REFINED_ICONTRACT_RESPONSE() \
true  && (COMPONENT_Pump_VAR_PORT_oil_INDEX==0->ICONTRACT_CONNECTOR_Customer_Pump_conn2_0_ROLE_Pump_PORTVAR_oil_ACTION_pump_PRE_RESPONSE: true) 
 #define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_ACTION_releasePump_REFINED_ICONTRACT() \
ICONTRACT_COMPONENT_Pump_PORT_fromCashier_ACTION_releasePump_PRE && (COMPONENT_Pump_VAR_PORT_fromCashier_INDEX==0->ICONTRACT_CONNECTOR_Cashier_Pump_conn3_0_ROLE_Pump_PORTVAR_fromCashier_ACTION_releasePump_PRE: true)  

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_CONNECTIONS 1
#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_0_CONNECTIONS 1


#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_SUMCONNECTIONS \
GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_CONNECTIONS 
#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_NUMOFCONNECTIONS \
(\
COMPONENT_Pump_VAR_PORT_oil_INDEX==0->GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_CONNECTIONS :0)\


#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_SUMCONNECTIONS \
GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_0_CONNECTIONS  
#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_NUMOFCONNECTIONS \
(\
COMPONENT_Pump_VAR_PORT_fromCashier_INDEX==0->GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_0_CONNECTIONS :0)\




#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_ACTION_pump_ROLE_DATAUPDATE_REQUEST() \
true

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_ACTION_pump_ROLE_DATAUPDATE_REQUEST() \
if\
::COMPONENT_Pump_VAR_PORT_oil_INDEX == 0 -> \
  GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_ACTION_pump_ROLE_DATAUPDATE_REQUEST() \
fi; 


#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_ACTION_pump_ROLE_DATAUPDATE_RESPONSE() \
true

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_ACTION_pump_ROLE_DATAUPDATE_RESPONSE() \
if\
::COMPONENT_Pump_VAR_PORT_oil_INDEX == 0 -> \
  GasStation_0_COMPONENT_Pump_pump1_0_PORT_oil_0_ACTION_pump_ROLE_DATAUPDATE_RESPONSE() \
fi; 


#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_0_ACTION_releasePump_ROLE_DATAUPDATE() \
true

#define GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_ACTION_releasePump_ROLE_DATAUPDATE() \
if\
::COMPONENT_Pump_VAR_PORT_fromCashier_INDEX == 0 -> \
  GasStation_0_COMPONENT_Pump_pump1_0_PORT_fromCashier_0_ACTION_releasePump_ROLE_DATAUPDATE() \
fi; 
 

#define COMPONENT_Pump_pump1_0_ROLE_DATA() \
 true 

c_code { 
int  Component_i_port_offsetArray(CompositeName,CompositeID,Pump,CompInstanceID,0,oil)[Component_i_Port_Num(CompositeName,CompositeID,Pump,CompInstanceID,0,oil)];
int Component_i_port_offsetArray(CompositeName,CompositeID,Pump,CompInstanceID,0,fromCashier)[Component_i_Port_Num(CompositeName,CompositeID,Pump,CompInstanceID,0,fromCashier)];
}


#define GasStation_0_COMPONENT_Pump_pump1_0_ARRAY_INITIALISATIONS() \
c_code { \ 
Component_i_port_offsetArray(CompositeName,CompositeID,Pump,CompInstanceID,0,oil)[0] = 0;\
Component_i_port_offsetArray(CompositeName,CompositeID,Pump,CompInstanceID,0,fromCashier)[0] = 0;\
} 

#define XX GasStation
#include "COMPONENT_TYPE_Pump_INSTANCE.pml"
#undef CompInstanceID 
#undef Instance 
#undef XX 
